Index: lib/TWiki.pm
===================================================================
--- lib/TWiki.pm	(revision 1767)
+++ lib/TWiki.pm	(working copy)
@@ -27,15 +27,6 @@
 #   custom rendering rules.
 # - Upgrading TWiki is easy as long as you only customize DefaultPlugin.pm.
 # - Check web server error logs for errors, i.e. % tail /var/log/httpd/error_log
-#
-# 20000501 Kevin Kinnell : changed beta0404 to have many new search
-#                          capabilities.  This file had a new hash added
-#                          for month name-to-number look-ups, a slight
-#                          change in the parameter list for the search
-#                          script call in &handleSearchWeb, and a new
-#                          sub -- &revDate2EpSecs -- for calculating the
-#                          epoch seconds from a rev date (the only way
-#                          to sort dates.)
 
 =begin twiki
 
@@ -45,17 +36,12 @@
 
 =cut
 
-
 package TWiki;
 
 use strict;
 
-use Time::Local;	# Added for revDate2EpSecs
-use Cwd qw( cwd ); 	# Added for getTWikiLibDir
-
 require 5.005;		# For regex objects and internationalisation
 
-# ===========================
 # TWiki config variables from TWiki.cfg:
 use vars qw(
         $defaultUserName $wikiHomeUrl $defaultUrlHost
@@ -86,18 +72,17 @@
 	$upperNational $lowerNational
     );
 
-# TWiki::Store config:
+# TWiki::Store config from TWiki.cfg
 use vars qw(
         $rcsDir $rcsArg $nullDev $endRcsCmd $storeTopicImpl $keywordMode
         $storeImpl @storeSettings
     );
 
-# TWiki::Search config:
+# TWiki::Search config from TWiki.cfg
 use vars qw(
         $cmdQuote $lsCmd $egrepCmd $fgrepCmd
     );
 
-# ===========================
 # Global variables
 
 # Refactoring Note: these are split up by "site" globals and "request"
@@ -109,97 +94,286 @@
 
 # Misc. Globals
 use vars qw(
-	@isoMonth @weekDay %userToWikiList %wikiToUserList $wikiversion
-	$TranslationToken %mon2num $viewScript $twikiLibDir $formatVersion
-	@publicWebList %regex
-    );
+            @isoMonth @weekDay $wikiversion
+            $TranslationToken $twikiLibDir $formatVersion
+            @publicWebList
+            %regex
+            %staticInternalTags
+            %dynamicInternalTags
+           );
 
 # Internationalisation (I18N) setup:
 use vars qw(
-	$siteCharset $useUnicode $siteLang $siteFullLang $urlCharEncoding 
-    );
+            $siteCharset $useUnicode $siteLang $siteFullLang $urlCharEncoding
+           );
 
-# ---------------------------
 # Per-Request "Global" Variables
 use vars qw(
-        $webName $topicName $includingWebName $includingTopicName
-	$userName $wikiName $wikiUserName $urlHost
-	$debugUserTime $debugSystemTime $script
-	$pageMode $readTopicPermissionFailed $cgiQuery $basicInitDone
-    );
-    
-# ===========================
-# Exports
+            $webName $topicName
+            $userName $wikiName $wikiUserName $urlHost
+            $debugUserTime $debugSystemTime $script
+            $readTopicPermissionFailed $cgiQuery $basicInitDone
+            %sessionInternalTags
+            %preferencesTags
+           );
 
-# The Render module needs to access a lot of configuration flags from
-# TWiki.cfg, so we export them here.  We also export the %regex hash
-# and a few other useful constants.
-
-use vars qw(@EXPORT_OK %EXPORT_TAGS @ISA);
-
-BEGIN {
-    require Exporter;
-    @ISA = qw(Exporter);
-    
-    %EXPORT_TAGS = (
-	renderflags => [qw($siteLang $securityFilter $twikiWebname $mainWebname
-	    $mainTopicname $scriptSuffix $doPluralToSingular
-	    $dispScriptUrlPath $dispViewPath
-	)]
-    );
-    
-    @EXPORT_OK = qw(%regex $TranslationToken);
-    Exporter::export_ok_tags('renderflags');
-}
-
-# ===========================
 # TWiki version:
 $wikiversion      = '20 Oct 2004 $Rev$';
 
-# ===========================
-# Key Global variables, required for writeDebug
+# Key Global variables
 # (new variables must be declared in "use vars qw(..)" above)
 @isoMonth = ( "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" );
 @weekDay = ("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat");
 
-{ 
-    my $count = 0;
-    %mon2num = map { $_ => $count++ } @isoMonth; 
+# Run-time locale setup - If $useLocale is set, this function parses
+# $siteLocale from TWiki.cfg and passes it to the POSIX::setLocale
+#  function to change TWiki's operating environment.
+#
+# SMELL: mod_perl compatibility note: If TWiki is running under Apache,
+# won't this play with the Apache process's locale settings too?
+# What effects would this have?
+#
+# Note that 'use locale' must be done in BEGIN block for regexes and sorting to
+# work properly, although regexes can still work without this in
+# 'non-locale regexes' mode (see _setupRegexes).
+
+sub _setupLocale {
+    $siteCharset = 'ISO-8859-1';	# Default values if locale mis-configured
+    $siteLang = 'en';
+    $siteFullLang = 'en-us';
+
+    if ( $useLocale ) {
+        if ( not defined $siteLocale or $siteLocale !~ /[a-z]/i ) {
+            die "\$useLocale set but \$siteLocale $siteLocale unset or has no alphabetic characters";
+        }
+        # Extract the character set from locale and use in HTML templates
+        # and HTTP headers
+        $siteLocale =~ m/\.([a-z0-9_-]+)$/i;
+        $siteCharset = $1 if defined $1;
+        $siteCharset =~ s/^utf8$/utf-8/i;	# For convenience, avoid overrides
+        $siteCharset =~ s/^eucjp$/euc-jp/i;
+
+        # Override charset - used when locale charset not supported by Perl
+        # conversion modules
+        $siteCharset = $siteCharsetOverride || $siteCharset;
+        $siteCharset = lc $siteCharset;
+
+        # Extract the default site language - ignores '@euro' part of
+        # 'fr_BE@euro' type locales.
+        $siteLocale =~ m/^([a-z]+)_([a-z]+)/i;
+        $siteLang = (lc $1) if defined $1;	# Not including country part
+        $siteFullLang = (lc "$1-$2" ) 		# Including country part
+          if defined $1 and defined $2;
+
+        # Set environment variables for grep 
+        $ENV{'LC_CTYPE'}= $siteLocale;
+
+        # Load POSIX for I18N support. Eval because otherwise
+        # it gets compiled even if we don't have a locale
+        eval 'require POSIX; import POSIX qw( locale_h LC_CTYPE );';
+
+        # Set new locale
+        my $locale = setlocale(&LC_CTYPE, $siteLocale);
+    }
+    $staticInternalTags{CHARSET} = $siteCharset;
+    $staticInternalTags{SHORTLANG} = $siteLang;
+    $staticInternalTags{LANG} = $siteFullLang;
 }
 
-# ===========================
-# Read the configuration file at compile time in order to set locale
+# Set up pre-compiled regexes for use in rendering.  All regexes with
+# unchanging variables in match should use the '/o' option, even if not in a
+# loop.
+sub _setupRegexes { 
+    $regex{linkProtocolPattern} = "(file|ftp|gopher|https|http|irc|news|nntp|telnet)";
+
+    # Header patterns based on '+++'. The '###' are reserved for numbered
+    # headers
+    # '---++ Header', '---## Header'
+    $regex{headerPatternDa} = '^---+(\++|\#+)\s*(.+)\s*$';
+    # '   ++ Header', '   + Header'
+    $regex{headerPatternSp} = '^\t(\++|\#+)\s*(.+)\s*$';
+    # '<h6>Header</h6>
+    $regex{headerPatternHt} = '^<h([1-6])>\s*(.+?)\s*</h[1-6]>';
+    # '---++!! Header' or '---++ Header %NOTOC% ^top'
+    $regex{headerPatternNoTOC} = '(\!\!+|%NOTOC%)';
+
+    # Build up character class components for use in regexes.
+    # Depends on locale mode and Perl version, and finally on
+    # whether locale-based regexes are turned off.
+    my ( $ua, $la, $num, $ma );
+    if ( not $useLocale or $] < 5.006 or not $localeRegexes ) {
+        # No locales needed/working, or Perl 5.005_03 or lower, so just use
+        # any additional national characters defined in TWiki.cfg
+        $ua = "A-Z$upperNational";
+        $la = "a-z$lowerNational";
+        $num = '\d';
+        $ma = "$ua$la";
+    } else {
+        # Perl 5.006 or higher with working locales
+        $ua = "[:upper:]";
+        $la = "[:lower:]";
+        $num = "[:digit:]";
+        $ma = "[:alpha:]";
+    }
+    $regex{upperAlpha} = $ua;
+    $regex{lowerAlpha} = $la;
+    $regex{numeric} = $num;
+    $regex{mixedAlpha} = $ma;
+
+    my $man = "$ma$num";
+    $regex{mixedAlphaNum} = $man;
+    my $lan = "$la$num";
+    $regex{lowerAlphaNum} = $lan;
+    my $uan = "$ua$num";
+    $regex{upperAlphaNum} = $uan;
+
+    # Compile regexes for efficiency and ease of use
+    # Note: qr// locks in regex modes (i.e. '-xism' here) - see Friedl
+    # book at http://regex.info/. 
+
+    # TWiki concept regexes
+    $regex{wikiWordRegex} = qr/[$ua]+[$la]+[$ua]+[$man]*/o;
+    $regex{webNameRegex} = qr/[$ua]+[$man]*/o;
+    $regex{defaultWebNameRegex} = qr/_[${man}_]+/o;
+    $regex{anchorRegex} = qr/\#[${man}_]+/o;
+    $regex{abbrevRegex} = qr/[$ua]{3,}s?\b/o;
+
+    # Simplistic email regex, e.g. for WebNotify processing - no i18n
+    # characters allowed
+    $regex{emailAddrRegex} = qr/([A-Za-z0-9\.\+\-\_]+\@[A-Za-z0-9\.\-]+)/;
+
+    # Filename regex, for attachments
+    $regex{filenameRegex} = qr/[$man\.]+/o;
+
+    # Multi-character alpha-based regexes
+    $regex{mixedAlphaNumRegex} = qr/[$man]*/o;
+
+    # Character encoding regexes
+
+    # 7-bit ASCII only
+    $regex{validAsciiStringRegex} = qr/^[\x00-\x7F]+$/o;
+
+    # Regex to match only a valid UTF-8 character, taking care to avoid
+    # security holes due to overlong encodings by excluding the relevant
+    # gaps in UTF-8 encoding space - see 'perldoc perlunicode', Unicode
+    # Encodings section.  Tested against Markus Kuhn's UTF-8 test file
+    # at http://www.cl.cam.ac.uk/~mgk25/ucs/examples/UTF-8-test.txt.
+    $regex{validUtf8CharRegex} = qr{
+				# Single byte - ASCII
+				[\x00-\x7F] 
+				|
+
+				# 2 bytes
+				[\xC2-\xDF][\x80-\xBF] 
+				|
+
+				# 3 bytes
+
+				    # Avoid illegal codepoints - negative lookahead
+				    (?!\xEF\xBF[\xBE\xBF])	
+
+				    # Match valid codepoints
+				    (?:
+					([\xE0][\xA0-\xBF])|
+					([\xE1-\xEC\xEE-\xEF][\x80-\xBF])|
+					([\xED][\x80-\x9F])
+				    )
+				    [\x80-\xBF]
+				|
+
+				# 4 bytes 
+				    (?:
+					([\xF0][\x90-\xBF])|
+					([\xF1-\xF3][\x80-\xBF])|
+					([\xF4][\x80-\x8F])
+				    )
+				    [\x80-\xBF][\x80-\xBF]
+			    }xo;
+
+    $regex{validUtf8StringRegex} =
+      qr/^ (?: $regex{validUtf8CharRegex} )+ $/xo;
+
+}
+
+sub _setupHandlerMaps {
+    # When processTags matches a tag it looks up the
+    # tag in the tables below, and either does a literal
+    # expansion or calls the relevant _handle method for
+    # the tag.
+    %staticInternalTags =
+      (
+       ENDSECTION      => "",
+       HOMETOPIC       => $mainTopicname,
+       MAINWEB         => $mainWebname,
+       NOTIFYTOPIC     => $notifyTopicname,
+       PUBURLPATH      => $pubUrlPath,
+       SCRIPTSUFFIX    => $scriptSuffix,
+       SCRIPTURLPATH   => $dispScriptUrlPath,
+       SECTION         => "",
+       STARTINCLUDE    => "",
+       STATISTICSTOPIC => $statisticsTopicname,
+       STOPINCLUDE     => "",
+       TWIKIWEB        => $twikiWebname,
+       WEBPREFSTOPIC   => $webPrefsTopicname,
+       WIKIHOMEURL     => $wikiHomeUrl,
+       WIKIPREFSTOPIC  => $wikiPrefsTopicname,
+       WIKITOOLNAME    => $wikiToolName,
+       WIKIUSERSTOPIC  => $wikiUsersTopicname,
+       WIKIVERSION     => $wikiversion,
+      );
+
+    %dynamicInternalTags =
+      (
+       ATTACHURLPATH     => \&_handleATTACHURLPATH,
+       DATE              => \&_handleDATE,
+       DISPLAYTIME       => \&_handleDISPLAYTIME,
+       ENCODE            => \&_handleENCODE,
+       FORMFIELD         => \&_handleFORMFIELD,,
+       GMTIME            => \&_handleGMTIME,
+       HTTP_HOST         => \&_handleHTTP_HOST,
+       ICON              => \&_handleICON,
+       INCLUDE           => \&_handleINCLUDE,
+       INTURLENCODE      => \&_handleINTURLENCODE,
+       METASEARCH        => \&_handleMETASEARCH,
+       PLUGINVERSION     => \&_handlePLUGINVERSION,
+       RELATIVETOPICPATH => \&_handleRELATIVETOPICPATH,
+       REMOTE_ADDR       => \&_handleREMOTE_ADDR,
+       REMOTE_PORT       => \&_handleREMOTE_PORT,
+       REMOTE_USER       => \&_handleREMOTE_USER,
+       REVINFO           => \&_handleREVINFO,
+       SEARCH            => \&_handleSEARCH,
+       SERVERTIME        => \&_handleSERVERTIME,
+       SPACEDTOPIC       => \&_handleSPACEDTOPIC,
+       "TMPL:P"          => \&_handleTMPLP,,
+       TOPICLIST         => \&_handleTOPICLIST,
+       URLENCODE         => \&_handleENCODE,
+       URLPARAM          => \&_handleURLPARAM,
+       VAR               => \&_handleVAR,
+       WEBLIST           => \&_handleWEBLIST,
+      );
+}
+
 BEGIN {
+    # Read the configuration file at compile time in order to set locale
     do "TWiki.cfg";
 
-    # Do a dynamic 'use locale' for this module
     if( $useLocale ) {
-        require locale;
-	import locale ();
+        eval 'require locale; import locale ();';
     }
+
+    _setupHandlerMaps();
+    _setupLocale();
+    _setupRegexes();
 }
 
-sub writeDebug;
-sub writeWarning;
-
-
-# ===========================
-# use TWiki and other modules
 use TWiki::Prefs;     # preferences
-use TWiki::Search;    # search engine
 use TWiki::Access;    # access control
-use TWiki::Meta;      # Meta class - topic meta data
 use TWiki::Store;     # file I/O and rcs related functions
-use TWiki::Attach;    # file attachment functions
-use TWiki::Form;      # forms for topics
-use TWiki::Func;      # official TWiki functions for plugins
-use TWiki::Plugins;   # plugins handler  #AS
-use TWiki::Net;       # SMTP, get URL
+use TWiki::Plugins;   # plugins handler
 use TWiki::User;
-use TWiki::Render;
+use TWiki::Render;    # HTML generation
+use TWiki::Templates; # TWiki template language
 
-
-# ===========================
 # Other Global variables
 
 # Token character that must not occur in any normal text - converted
@@ -210,16 +384,7 @@
 # initialize not called.
 $cgiQuery = 0;
 @publicWebList = ();
-$viewScript = "view";
 
-$regex{linkProtocolPattern} = "(file|ftp|gopher|http|https|irc|news|nntp|telnet)";
-
-# Header patterns based on '+++'. The '###' are reserved for numbered headers
-$regex{headerPatternDa} = '^---+(\++|\#+)\s*(.+)\s*$';       # '---++ Header', '---## Header'
-$regex{headerPatternSp} = '^\t(\++|\#+)\s*(.+)\s*$';         # '   ++ Header', '   + Header'
-$regex{headerPatternHt} = '^<h([1-6])>\s*(.+?)\s*</h[1-6]>'; # '<h6>Header</h6>
-$regex{headerPatternNoTOC} = '(\!\!+|%NOTOC%)';  # '---++!! Header' or '---++ Header %NOTOC% ^top'
-
 $debugUserTime   = 0;
 $debugSystemTime = 0;
 
@@ -227,88 +392,78 @@
 
 $basicInitDone = 0;		# basicInitialize not yet done
 
-$pageMode = 'html';		# Default is to render as HTML
+# Concatenates date, time, and $text to a log file.
+# The logfilename can optionally use a %DATE% variable to support
+# logs that are rotated once a month.
+# | =$log= | Base filename for log file |
+# | =$message= | Message to print |
+sub _writeReport {
+    my ( $log, $message ) = @_;
 
-=pod
-
----++ writeWarning( $text )
-
-Prints date, time, and contents $text to $warningFilename, typically
-'warnings.txt'.  Use for warnings and errors that may require admin
-intervention.  Not using Store::writeLog; log file is more of an audit/usage
-file.  Use this for defensive programming warnings (e.g. assertions).
-
-=cut
-
-sub writeWarning {
-    my( $text ) = @_;
-    if( $warningFilename ) {
+    if ( $log ) {
         my ( $sec, $min, $hour, $mday, $mon, $year ) = localtime( time() );
-	my( $tmon) = $isoMonth[$mon];
+        my $yearmonth = sprintf( "%.4u%.2u", $year, $mon+1 );
+        $log =~ s/%DATE%/$yearmonth/go;
+
+        my( $tmon) = $isoMonth[$mon];
         $year = sprintf( "%.4u", $year + 1900 );
         my $time = sprintf( "%.2u ${tmon} %.2u - %.2u:%.2u",
-			   $mday, $year, $hour, $min );
+                            $mday, $year, $hour, $min );
 
-        if( open( FILE, ">>$warningFilename" ) ) {
-            print FILE "$time $text\n";
+        if( open( FILE, ">>$log" ) ) {
+            print FILE "| $time | $message\n";
             close( FILE );
         } else {
-            print STDERR "Couldn't write \"$text\" to $warningFilename: $!\n";
+            print STDERR "Couldn't write \"$message\" to $log: $!\n";
         }
     }
 }
 
 =pod
 
----++ writeDebug( $text )
+---++ sub writeLog (  $action, $webTopic, $extra, $user  )
 
-Prints date, time, and contents of $text to $debugFilename, typically
-'debug.txt'.  Use for debugging messages.
+Write the log for an event to the logfile
 
 =cut
 
-sub writeDebug {
-    my( $text ) = @_;
-    
-    my ( $sec, $min, $hour, $mday, $mon, $year ) = localtime( time() );
-    my( $tmon) = $isoMonth[$mon];
-    $year = sprintf( "%.4u", $year + 1900 );
-    my $time = sprintf( "%.2u ${tmon} %.2u - %.2u:%.2u", $mday, $year, $hour, $min );
+sub writeLog
+{
+    my( $action, $webTopic, $extra, $user ) = @_;
 
-    if( open( FILE, ">>$debugFilename" ) ) {
-         print FILE "$time $text\n";
-         close( FILE );
-    } else {
-         print STDERR "Couldn't write \"$text\" to $debugFilename: $!\n";
-    }
+    my $wuserName = $user || $userName;
+    $wuserName = TWiki::User::userToWikiName( $wuserName );
+    my $remoteAddr = $ENV{'REMOTE_ADDR'} || "";
+    my $text = "$wuserName | $action | $webTopic | $extra | $remoteAddr |";
+
+    _writeReport( $logFilename, $text );
 }
 
 =pod
 
----++ writeDebugTimes( $text )
+---++ writeWarning( $text )
 
-Dumps user and system time spent, with deltas from last call, followed
-by contents of $text, to debug log using writeDebug above.  Use for
-performance monitoring/debugging.
+Prints date, time, and contents $text to $warningFilename, typically
+'warnings.txt'. Use for warnings and errors that may require admin
+intervention. Use this for defensive programming warnings (e.g. assertions).
 
 =cut
 
-sub writeDebugTimes
-{
-    my( $text ) = @_;
+sub writeWarning {
+    _writeReport( $warningFilename, @_ );
+}
 
-    if( ! $debugUserTime ) {
-        writeDebug( "===      sec (delta:)     sec (delta:)     sec   function:" );
-    }
-    my( $puser, $psystem, $cuser, $csystem ) = times();
-    my $duser = $puser - $debugUserTime;
-    my $dsystem = $psystem - $debugSystemTime;
-    my $times = sprintf( "usr %1.2f (%1.2f), sys %1.2f (%1.2f), sum %1.2f",
-                  $puser, $duser, $psystem, $dsystem, $puser+$psystem );
-    $debugUserTime   = $puser;
-    $debugSystemTime = $psystem;
+=pod
 
-    writeDebug( "==> $times,  $text" );
+---++ writeDebug( $text )
+
+Prints date, time, and contents of $text to $debugFilename, typically
+'debug.txt'.  Use for debugging messages.
+
+=cut
+
+sub writeDebug {
+    _writeReport( $debugFilename, @_ );
 }
 
 =pod
@@ -328,26 +483,20 @@
 
 =cut
 
-sub initialize
-{
+sub initialize {
     my ( $thePathInfo, $theRemoteUser, $theTopic, $theUrl, $theQuery ) = @_;
-    
-    if( not $basicInitDone ) {
-	basicInitialize();
-    }
 
-    ##writeDebug( "\n---------------------------------" );
+    basicInitialize() unless( $basicInitDone );
 
     $cgiQuery = $theQuery;
-    
-    # Initialise vars here rather than at start of module,
+
+    # Initialise per-session vars here rather than at start of module,
     # so compatible with modPerl
     @publicWebList = ();
-    &TWiki::Store::initialize();
+    TWiki::Store::initialize();
+    TWiki::User::initialize();
 
-    &TWiki::User::initialize();
-
-    # Make %ENV safer for CGI
+    # Make %ENV safer, preventing hijack of the search path
     if( $safeEnvPath ) {
         $ENV{'PATH'} = $safeEnvPath;
     }
@@ -357,7 +506,7 @@
     getTWikiLibDir();
 
     # initialize access control
-    &TWiki::Access::initializeAccess();
+    TWiki::Access::initializeAccess();
     $readTopicPermissionFailed = ""; # Will be set to name(s) of topic(s) that can't be read
 
     # initialize $webName and $topicName from URL
@@ -385,7 +534,6 @@
     # invalid PATH_INFO is often a full path starting with '/cgi-bin/...'.
     my $cgiScriptName = $ENV{'SCRIPT_NAME'} || "";
     $thePathInfo =~ s!$cgiScriptName/!/!i;
-    ## writeDebug( "===== thePathInfo after cleanup = $thePathInfo" );
 
     # Get the web and topic names from PATH_INFO
     if( $thePathInfo =~ /\/(.*)[\.\/](.*)/ ) {
@@ -401,11 +549,11 @@
     # Refuse to work with character sets that allow TWiki syntax
     # to be recognised within multi-byte characters.  Only allow 'oops'
     # page to be displayed (redirect causes this code to be re-executed).
-    if ( invalidSiteCharset() and $theUrl !~ m!$scriptUrlPath/oops! ) {  
-	writeWarning "Cannot use this multi-byte encoding ('$siteCharset') as site character encoding";
-	writeWarning "Please set a different character encoding in the \$siteLocale setting in TWiki.cfg.";
-        my $url = &TWiki::getOopsUrl( $webName, $topicName, "oopsbadcharset" );
-	print $cgiQuery->redirect( $url );
+    if ( _invalidSiteCharset() and $theUrl !~ m!$scriptUrlPath/oops! ) {  
+        writeWarning( "Cannot use this multi-byte encoding ('$siteCharset') as site character encoding" );
+        writeWarning( "Please set a different character encoding in the \$siteLocale setting in TWiki.cfg." );
+        my $url = TWiki::getOopsUrl( $webName, $topicName, "oopsbadcharset" );
+        print $cgiQuery->redirect( $url );
         return;
     }
 
@@ -420,8 +568,6 @@
     $webName   =~ s/$securityFilter//go;
     $webName   =~ /(.*)/;
     $webName   = $1 || $mainWebname;  # untaint variable
-    $includingTopicName = $topicName;
-    $includingWebName = $webName;
 
     # initialize $urlHost and $scriptUrlPath 
     if( ( $theUrl ) && ( $theUrl =~ m!^([^:]*://[^/]*)(.*)/.*$! ) && ( $2 ) ) {
@@ -435,42 +581,45 @@
     } else {
         $urlHost = $defaultUrlHost;
     }
-    # PTh 15 Jul 2001: Removed init of $scriptUrlPath based on $theUrl because
-    # $theUrl has incorrect URI after failed authentication
 
     # initialize preferences, first part for site and web level
-    &TWiki::Prefs::initializePrefs( $webName );
+    TWiki::Prefs::initializePrefs( $webName );
 
-    # initialize user name and user to WikiName list
-    userToWikiListInit();
     if( !$disableAllPlugins ) {
-            # Early plugin initialization, allow plugins like SessionPlugin
+        # Early plugin initialization, allow plugins like SessionPlugin
 	    # to set the user.  This must be done before preferences are set,
 	    # as we need to get user preferences
-            $userName = &TWiki::Plugins::initialize1( $topicName, $webName, $theRemoteUser, $theUrl, $thePathInfo );
+        $userName = TWiki::Plugins::initialize1( $topicName, $webName, $theRemoteUser, $theUrl, $thePathInfo );
     }
-    $wikiName     = userToWikiName( $userName, 1 );      # i.e. "JonDoe"
-    $wikiUserName = userToWikiName( $userName );         # i.e. "Main.JonDoe"
+    $wikiName     = TWiki::User::userToWikiName( $userName, 1 );      # i.e. "JonDoe"
+    $wikiUserName = TWiki::User::userToWikiName( $userName );         # i.e. "Main.JonDoe"
 
+    $sessionInternalTags{USERNAME} = $userName;
+    $sessionInternalTags{WIKINAME} = $wikiName;
+    $sessionInternalTags{WIKIUSERNAME} = $wikiUserName;
+    $sessionInternalTags{BASEWEB} = $webName;
+    $sessionInternalTags{BASETOPIC} = $topicName;
+    $sessionInternalTags{INCLUDINGTOPIC} = $topicName;
+    $sessionInternalTags{INCLUDINGWEB} = $webName;
+    $sessionInternalTags{ATTACHURL} = "$urlHost%ATTACHURLPATH%";
+    $sessionInternalTags{PUBURL} = "$urlHost$pubUrlPath";
+    $sessionInternalTags{SCRIPTURL} = "$urlHost$dispScriptUrlPath";
+
     # initialize preferences, second part for user level
-    &TWiki::Prefs::initializeUserPrefs( $wikiUserName );
+    TWiki::Prefs::initializeUserPrefs( $wikiUserName );
 
-    # some remaining init
-    $viewScript = "view";
-    if( ( $ENV{'SCRIPT_NAME'} ) && ( $ENV{'SCRIPT_NAME'} =~ /^.*\/viewauth$/ ) ) {
-        # Needed for TOC
-        $viewScript = "viewauth";
-    }
-    
     TWiki::Render::initialize();
 
-#AS
     if( !$disableAllPlugins ) {
         # Normal plugin initialization - userName is known and preferences available
-        &TWiki::Plugins::initialize2( $topicName, $webName, $userName );
+        TWiki::Plugins::initialize2( $topicName, $webName, $userName );
     }
-#/AS
 
+    # Assumes all preferences values are set by now, which may well be false!
+    # It would be better to get the Prefs module to maintain this
+    # hash.
+    TWiki::Prefs::loadHash( \%preferencesTags );
+
     return ( $topicName, $webName, $scriptUrlPath, $userName, $dataDir );
 }
 
